var sku = "everpremium";

var noteStoreURL;
var authenticationToken;
var noteStoreTransport;
var noteStoreProtocol;
var noteStore;
var userStore;

var allNotes = {};
var allNotebooks = {};
var allStacks = [];
var allNotebookStacks = {};
var allNotebooksReversed = {};
var allTags = {};
var allTagsReversed = {};
var numberOfNotebooks = 0;
var numberOfTags = 0;

// Number of notes to load in first getNotes API call
var FIRST_PAGE_SIZE = 25;
// Number of notes to load in subsequent getNotes API calls (if notes count is more than FIRST_PAGE_SIZE) 
var NTH_PAGE_SIZE = 50; 
// Maximum Total number of notes to be loaded for a user.
var TOTAL_NOTES_LIMIT = 2000;

var changedNotes = true;
var changedNotebooks = true;
var changedTags = true;
var changedShortcuts = true;

var lastShowedNote;
var isNewNote = false;
var isEmptyNote = false;

var notesClickedFirstTime = false;
var tagsClickedFirstTime = false;
var notebooksClickedFirstTime = false;
var shortcutsClickedFirstTime = false;

var shortcutsTagIsCreated = false;

var loadedNotebooks = false;
var loadedTags = false;

var isInsideNotebooks = false;
var isInsideTags = false;
var lastOpenedNotebook;
var lastOpenedTag;

var clickedNotes = false;
var clickedShortcuts = false;
var clickedTags = false;
var clickedNotebooks = false;

var todoCheckbox = '<input class="en-todo-image" src="images/todo_unchecked.gif" type="image" data-checked="false" />';
var noteIsSaved = true;

var lastOpenedTab = localStorage['lastOpenedTab'];

var nrClicksAddNewTagBtn = 0;

var typeOfLicense = "FREE";
var productPurchased = false;
var gotStoreResponse = false;

var featuresAvailable = false;
var webstoreLink = "https://chrome.google.com/webstore/detail/evernote-for-chrome/" + chrome.runtime.id;

function connectToBackgroundScript () {
	console.log('Creating port with background script');

	backgroundScriptPort = chrome.runtime.connect({ name: "Popup-BackgroundScript" });
	
	backgroundScriptPort.onMessage.addListener(function(msg) {    
		
		console.log("Received msg from background script: " + msg.type);
		switch(msg.type) {
			case "notesSynced": notesSynced(msg); break;
		}
	});
}

function sendMessageOverPort(msg) {
	if(backgroundScriptPort) {
		console.log('Sent message to background script: ' + msg.type);
		backgroundScriptPort.postMessage(msg);
	} else {
		console.error('No port found for sending message from popup to background script');
	}
}

connectToBackgroundScript();

function showBuyLicenseBanner() {
	$('.purchase-license-banner').show();
}

function hideBuyLicenseBanner() {
	$('.purchase-license-banner').hide();
}

function showTrialExpiredMessage() {
	showBuyLicenseBanner();
}

function showGetPremiumUserMessage() {
	showBuyLicenseBanner();
}

//it will return "TRIAL_EXPIRED" or "FULL"
function getTypeOfLicense(callback) {
	var purchaseStatus = productPurchased ? "FULL" : "TRIAL_EXPIRED";
	callback(purchaseStatus); 
}

function getProductList() {
	google.payments.inapp.getSkuDetails({
	    'parameters': {env: "prod"},
	    'success': onSkuDetails,
	    'failure': onSkuDetailsFailed
	});
}

function onSkuDetails(response) {
 // console.log("onSkuDetails", response);
  var products = response.response.details.inAppProducts;
  var count = products.length;
  //console.log("There are "+count+" products for sale");
  for (var i = 0; i < count; i++) {
    var product = products[i];
  }
}

function onSkuDetailsFailed(response) {
  //console.log("onSkuDetailsFailed", response);
   //console.log(JSON.stringify(response));
}

/*****************************************************************************
* Get the list of purchased products from the Chrome Web Store
*****************************************************************************/
function getLicenses() {
  //console.log("google.payments.inapp.getPurchases");
  google.payments.inapp.getPurchases({
    'parameters': {env: "prod"},
    'success': onLicenseUpdate,
    'failure': onLicenseUpdateFailed
  });
}

function onLicenseUpdate(response) {
  //console.log("onLicenseUpdate", response);
  
  var licenses = response.response.details;
  var count = licenses.length;
  //console.log("There are "+count+" products purchased");
  
  var activeLicenses = _.find(licenses, function(license) {
  	console.log("license: " + JSON.stringify(license));
  	return ((license['sku'].indexOf(sku) !== -1) && license['state'] === "ACTIVE");
  });

  productPurchased = !_.isEmpty(activeLicenses) ? true : false;

  gotStoreResponse = true;
}

function onLicenseUpdateFailed(response) {
  //console.log("onLicenseUpdateFailed->Error retreiving list of purchased products ", response);
  gotStoreResponse = true;
}

function waitStoreResponse() {
	if(gotStoreResponse == false) {
		setTimeout(function(){waitStoreResponse()}, 100);
	}
	else {
		getTypeOfLicense(function(type) {

			//console.log("Type of license is " + type);
			
			if(type == "TRIAL_EXPIRED") {
				$("#getPremium").show();
			}
			featuresAvailable = (type === "FULL") ? true : false;
		});
	}
}

getLicenses();

waitStoreResponse();


if(localStorage['token'] && localStorage['token'].length > 1) {
	noteStoreURL = localStorage['noteStoreUrl'];
	authenticationToken = localStorage['token'];
	noteStoreTransport = new Thrift.BinaryHttpTransport(noteStoreURL);
	noteStoreProtocol = new Thrift.BinaryProtocol(noteStoreTransport);
	noteStore = new NoteStoreClient(noteStoreProtocol);

	window.setTimeout(function() {
		sendMessageOverPort({ type: 'init' });
	}, 2000);
	
	if(!localStorage["userId"]) {
		var userStoreURL = "https://www.evernote.com/edam/user"
		var userStoreTransport = new Thrift.BinaryHttpTransport(userStoreURL);
		var userStoreProtocol = new Thrift.BinaryProtocol(userStoreTransport);

		userStore = new UserStoreClient(userStoreProtocol);

		userStore.getUser(localStorage['token'], function(user) {
			if(user && user.id) {
				var oldInstallationDate;
				chrome.storage.sync.get("installedDate", function(instDate) {
					if(instDate && instDate.installedDate) {
						oldInstallationDate = instDate.installedDate;
					}
					else {
						//first time when the user has installed the extension
						chrome.storage.sync.set({"installedDate": new Date().getTime()}, function() {
							localStorage['installedDate'] = new Date().getTime();
						})
					}
				})
				
			}
		})
	}	
}

function initLogin() {
	chrome.runtime.sendMessage({type: "login1"}, function(response) {
	});
	 setTimeout(function(){
                chrome.tabs.query({}, function(tabs){
                    for(var i = 0; i < tabs.length; i++) {
                        if(tabs[i].url.indexOf('/OAuth.action?oauth_token='+tempToken) >= 0) {
                           
                            /*chrome.extension.getBackgroundPage().console.log("okkk");
                            console.log($("#login_form > ol > li > label").html());
                            chrome.extension.getBackgroundPage().alert(($("#login_form > ol > li > label").html()))*/
                            document.getElementById('login').addEventListener('click', function() {
                            	localStorage['email'] = document.getElementById('username').innerHTML;
                            	//console.log(localStorage['email']);
                            })
                        }
                    }
                })
            }, 1000);
}


document.getElementById('btnSubmit').addEventListener('click', initLogin);

document.addEventListener('DOMContentLoaded', function() {
	if(!(localStorage['token'] && localStorage['token'].length > 1)) {
		$('#container').hide();
		$('#lgnBtn').show();
	}
})

function placeAttachmentDiv(hasTags) {
	var pos = $("#belowLine").position();
	$("#attachments").css("top", (pos.top+58)+"px!important");
	$("#attachmentsL").css("top", (pos.top+52)+"px!important");
	$("#attachments").css("left", pos.left+"px");
}

function addResources(resources) {	
	var htmlResources = "";
	var nrRsc = resources.length;
	
	for(var i = 0; i < resources.length; i++) {
		htmlResources += "<li id=\"att_"+resources[i].guid+"\"><a class=\"insideAttachments\" id=\"atta_"+resources[i].guid+"\""+"href=\"#\">"+resources[i].attributes.fileName+"</a></li>";
	}

	$("#attachmentsList").html(htmlResources);

	for(var i = 0 ; i < resources.length; i++) {
		$("#att_"+resources[i].guid).click(function(ev){
			var resourceGuid = ev.currentTarget.attributes[0].nodeValue.split('att_')[1];
			var resourceUrl = localStorage['baseURL']+'res/'+resourceGuid+'/'+($("#atta_"+resourceGuid).html());

			window.open(resourceUrl, '_blank');

			$("#attachmentsL").hide();
		})
	}

	var hg = nrRsc*30 + 3;
	if(nrRsc == 0)
		hg = 0;
	if(hg>90)
		hg = 90;
	$("#attachmentsL").css("height", hg+"px");
	$("#attachments").removeClass("hiddenHTMLTag");
}

function fitTextTitle() {
	if($("#title").html().length() < 50) {
		$("#title").css("font-size", "28px");
	}
	else {
		$("#title").css("font-size", "20px");
	}
}

function loadNote(guid) {
	nrClicksAddNewTagBtn = 0;
	if(guid)
		localStorage['lastOpenedNote'] = guid;

	localStorage['lastOpenedNoteTimestamp'] = new Date().getTime();

	noteStore.getNote(authenticationToken, localStorage['lastOpenedNote'], true, true, true, true, function(note) {
		if(note && note.errorCode && note.parameter && note.parameter == 'authenticationToken') {
			localStorage.removeItem('token');
			chrome.extension.getBackgroundPage().alert("Authentication token expired! Please login again!");
			window.close();
		}
		
		$('#title').html(note.title);

		$('.submenu > li > a').each(function(index){
			if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
				$(this).css("text-decoration", "underline");
				$(this).hover(
					function(){$(this).css("text-decoration", "underline")}, 
					function() {$(this).css("text-decoration", "underline")}
				);
			}
			else {
				$(this).css("text-decoration","none");
				$(this).hover(
					function(){$(this).css("text-decoration", "underline")}, 
					function() {$(this).css("text-decoration", "none")}
				);
			}
		});

		if(!loadedNotebooks){
			noteStore.getNotebook(authenticationToken, note.notebookGuid, function(ntb) {
				$('#currentFolder').html(ntb.name);
				localStorage[ntb.name] = (new Date()).getTime();
			})
		}
		else {
			$('#currentFolder').html(allNotebooksReversed[note.notebookGuid]);
			localStorage[allNotebooksReversed[note.notebookGuid]] = (new Date()).getTime(); 
		}

		var isShortcut = false;
		if(note.tagGuids || note.tagNames) {
			$("#newTagBtn").removeClass("showedHTMLTag");
			$("#newTagBtn").addClass("hiddenHTMLTag");

			$("#tagsBtn").removeClass("hiddenHTMLTag");
			$("#tagsBtn").addClass("showedHTMLTag");
			if(note.tagGuids != undefined && note.tagGuids.indexOf(localStorage['shortcutsGuid']) >= 0) {
				isShortcut = true;
			}
			if(loadedTags) {

				if(note.tagGuids) {
					//sa afisez toate tagurile
					var htmlTags = "";
					var nrTgs = note.tagGuids.length;
					note.tagGuids.sort(function(t1, t2){
						if(allTagsReversed[t1] > allTagsReversed[t2])   {
							return 1;
						}
						else
							return -1;
					})
					for(var i = 0; i < note.tagGuids.length; i++) {
						//console.log(allTagsReversed[note.tagGuids[i]]);
						if(allTagsReversed[note.tagGuids[i]] == 'shorcut') 
							isShortcut = true;
						htmlTags += "<li class=\"insideNoteTagList\">"+allTagsReversed[note.tagGuids[i]]+"</li>";
					}

					
					$("#noteTagsList").html(htmlTags);

					var hg = nrTgs*30 + 3;
					if(nrTgs == 0)
						hg = 0;
					if(hg>90)
						hg = 90;
					$("#noteTagsL").css("height", hg+"px");

					placeAttachmentDiv(true);
				}
				else {
					$("#noteTagsList").html("");
					$("#noteTagsL").css("height", "0px");
					placeAttachmentDiv(false);

				}
			}
			else {
				loadTags(true, function() {
					if(note.tagGuids) {
						var htmlTags = "";
						var nrTgs = note.tagGuids.length;
						note.tagGuids.sort(function(t1, t2){
							if(allTagsReversed[t1] > allTagsReversed[t2])   {
								return 1;
							}
							else
								return -1; 
						})
						for(var i = 0; i < note.tagGuids.length; i++) {
							//console.log(allTagsReversed[note.tagGuids[i]]);
							if(allTagsReversed[note.tagGuids[i]] == 'shorcut') 
								isShortcut = true;
							htmlTags += "<li class=\"insideNoteTagList\">"+allTagsReversed[note.tagGuids[i]]+"</li>";
						}

						
						$("#noteTagsList").html(htmlTags);

						var hg = nrTgs*30 + 3;
						if(nrTgs == 0)
							hg = 0;
						if(hg>90)
							hg = 90;
						$("#noteTagsL").css("height", hg+"px");
						placeAttachmentDiv(true);
					}
					else {
						$("#noteTagsList").html("");
						$("#noteTagsL").css("height", "0px");
						placeAttachmentDiv(false);
					}
					
				})
			}
		}
		else {
			$("#noteTagsList").html("");
			$("#noteTagsL").css("height", "0px");

			$("#tagsBtn").removeClass("showedHTMLTag");
			$("#tagsBtn").addClass("hiddenHTMLTag");

			$("#newTagBtn").removeClass("hiddenHTMLTag");
			$("#newTagBtn").addClass("showedHTMLTag");

			placeAttachmentDiv(false);

		}

		if(isShortcut) {
			//console.log('is shorcut');
			$(".shortcut-icon-wrap").addClass('shortcut-icon-active');
			$(".shortcut-icon-active").removeClass('shortcut-icon-wrap');
		}
		else {
			$(".shortcut-icon-active").addClass('shortcut-icon-wrap');
			$(".shortcut-icon-wrap").removeClass('shortcut-icon-active');	
		}

		if(note.content.indexOf("<en-note></en-note>") >= 0) {
			$('.content-wrap p').html('');
			isEmptyNote = true;
		}
		else {
			
			var tempDom = $('<div>').append($.parseHTML(note.content));
			var tempHtml = tempDom[0].innerHTML;
			tempHtml = tempHtml.replace(/en-todo checked="true"/g, 'en-todo checked="checked"');
			tempHtml = tempHtml.replace(/en-todo checked="false"/g, 'en-todo ');
			tempDom[0].innerHTML = tempHtml;

			var toDos = $(tempDom[0]).find("en-todo");

			_.each(toDos, function(toDo, index, list) {
				var checked, image; 
				if($(toDo).attr('checked') === "checked") {
					checked = "true";
					image = "images/todo_checked.gif";
				} else {
					checked = "false";
					image = "images/todo_unchecked.gif";
				}
				$(toDo).replaceWith('<input class="en-todo-image" src=' + image + ' type="image" data-checked=' + checked + ' />');
			});

			$('.content-wrap p').html(tempDom[0].innerHTML);

			attachTodoClickHandler();
			
			isEmptyNote = false;
			$("#noteContent")[0].scrollTop = $("#noteContent")[0].scrollHeight;
			setEndOfContenteditable($('#content-box')[0]);
		}


		if(note.resources) {
			addResources(note.resources);
		}
		else {
			if($("#attachments").is(":visible"))
				$("#attachments").addClass("hiddenHTMLTag");
		}
	}, onAPIError);
}

function attachTodoClickHandler() {
	$('.en-todo-image').off('click');

	$('.en-todo-image').on('click', function(event) {
		var el = $(event.currentTarget);
		if(el.attr('data-checked') === "true") {
			el.attr({ 'data-checked': "false",  'src': "images/todo_unchecked.gif" });
		} else {
			el.attr({ 'data-checked': "true", 'src': "images/todo_checked.gif" });
		}
	});
}

function loadMoreNotesFromNotebook(notebookGuid, start, numberOfNotes) {
	var filter = new NoteFilter();
	filter.notebookGuid = notebookGuid;
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	$('.notebooks .loadingMore').show();

	noteStore.findNotes(authenticationToken, filter, start, numberOfNotes, function (noteList) {
		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;
				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");
				$('#allNotebooks').append(
						
					$('<li>').attr('id','ntb_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
                
                // chrome update
				$('#ntb_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('ntb_')[1];
					lastShowedNote = guid;
					loadNote(guid);

				})


				if(i == nt.length - 1) {
					if(noteList.totalNotes > start + numberOfNotes) {
						setTimeout(function() {
							loadMoreNotesFromNotebook(notebookGuid,start+numberOfNotes,numberOfNotes);
						}, 1000)
					}
					else{
						$('.notebooks .loadingMore').hide();

						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}
			})(ii);
		}
	}, onAPIError);	
}

function loadNotesFromNotebook(notebookGuid) {
	isInsideNotebooks = true;
	lastOpenedNotebook = notebookGuid;
	var filter = new NoteFilter();
	filter.notebookGuid = notebookGuid;
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	noteStore.findNotes(authenticationToken, filter, 0, FIRST_PAGE_SIZE, function (noteList) {
		$('#allNotebooks').html('');

		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;
				
				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");

				$('#allNotebooks').append(
						
					$('<li>').attr('id','ntb_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
				$('#ntb_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('ntb_')[1];
					
					lastShowedNote = guid;
					loadNote(guid);

				})

				if(i == nt.length - 1) {
					if(noteList.totalNotes > FIRST_PAGE_SIZE) {
						setTimeout(function() {
							loadMoreNotesFromNotebook(notebookGuid, FIRST_PAGE_SIZE, NTH_PAGE_SIZE);
						}, 1000)
					}
					else {
						$('.notebooks .loadingMore').hide();

						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}

			})(ii);
		}
	}, onAPIError);	
}

function loadMoreNotesWithTag(tagGuid, start, numberOfNotes) {
	var filter = new NoteFilter();
	filter.tagGuids = [tagGuid];
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	$('.tags .loadingMore').show();

	noteStore.findNotes(authenticationToken, filter, start, numberOfNotes, function (noteList) {
		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;
				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");


				$('#allTags').append(
						
					$('<li>').attr('id','tg_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
				$('#tg_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('tg_')[1];
					lastShowedNote = guid;
					loadNote(guid);

				})

				if(i == nt.length - 1) {
					if(noteList.totalNotes > start + numberOfNotes) {
						setTimeout(function() {
							loadMoreNotesWithTag(tagGuid,start+numberOfNotes,numberOfNotes);
						}, 1000);
					}
					else {
						$('.tags .loadingMore').hide();
						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}
			})(ii);
		}
	}, onAPIError);	
}

function loadMoreShortcuts(start, numberOfNotes) {
	if(!localStorage['shortcutsGuid'])
		return;

	var tagGuid = localStorage['shortcutsGuid'];
	var filter = new NoteFilter();
	
	filter.tagGuids = [tagGuid];
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	$('.shortcuts .loadingMore').show();	
	noteStore.findNotes(authenticationToken, filter, start, numberOfNotes, function (noteList) {
		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;
				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");


				$('#allShortcuts').append(
						
					$('<li>').attr('id','sh_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
				$('#sh_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('sh_')[1];
					lastShowedNote = guid;
					loadNote(guid);

				})

				if(i == nt.length - 1) {
					if(noteList.totalNotes > start + numberOfNotes) {
						setTimeout(function() {
							loadMoreShortcuts(start+numberOfNotes, numberOfNotes);
						}, 1000);
					}
					else {
						$('.shortcuts .loadingMore').hide();
						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}

			})(ii);
		}
	}, onAPIError);	
}

function loadShortcuts() {

	$("#searchBox p").addClass("grayText");
	$("#searchBox p").attr("placeholder", "Find Note");
	
	if(changedShortcuts == false)
		return;
	else
		changedShortcuts = false;

	if(!localStorage['shortcutsGuid']) {
		return;
	}

	var tagGuid = localStorage['shortcutsGuid'];
	var filter = new NoteFilter();

	filter.tagGuids = [tagGuid];
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	noteStore.findNotes(authenticationToken, filter, 0, FIRST_PAGE_SIZE, function (noteList) {
		$('#allShortcuts').html('');


		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;

				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");


				$('#allShortcuts').append(
					$('<li>').attr('id','sh_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
				$('#sh_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('sh_')[1];
					lastShowedNote = guid;
					loadNote(guid);

				})

				if(i == nt.length - 1) {
					if(noteList.totalNotes > FIRST_PAGE_SIZE) {
						setTimeout(function() {
							loadMoreShortcuts(FIRST_PAGE_SIZE, NTH_PAGE_SIZE);
						}, 1000);
					}
					else {
						$('.shortcuts .loadingMore').hide();
						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}
			})(ii);
		}
	});	
}

function loadNotesWithTag(tagGuid) {
	isInsideTags = true;
	lastOpenedTag = tagGuid;
	var filter = new NoteFilter();
	filter.tagGuids = [tagGuid];
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	noteStore.findNotes(authenticationToken, filter, 0, FIRST_PAGE_SIZE, function (noteList) {
		$('#allTags').html('');


		var nt = noteList.notes;

		for(var ii = 0 ; ii < nt.length; ii++) {
			(function(i) {
				//console.log(nt[i]);
				allNotes[nt[i].guid] = nt[i].notebookGuid;
				var dt = new Date(nt[i].updated);
				var cdt = new Date();
				var showDate = true;
				if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
					showDate = false;

				var hours = dt.getHours();
				if(hours > 12)
					hours = hours + 1;
				if(hours == 0) {
					hours = 12;
				} 
				hours = hours % 13;
				hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");


				$('#allTags').append(
					$('<li>').attr('id','tg_'+nt[i].guid).append(
							$('<a />' , {
								href: "#",
								text: nt[i].title,
								class: "noteList"
							})
						).append($('<span>').attr('class','date-and-time').append(
								 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
							))
					)
				$('#tg_'+nt[i].guid).click(function(e) {
					var title = e.currentTarget.children[0].innerText;
					var guid = $(e.currentTarget).attr("id").split('tg_')[1];
					lastShowedNote = guid;
					loadNote(guid);

				})

				if(i == nt.length - 1) {
					if(noteList.totalNotes > FIRST_PAGE_SIZE) {
						setTimeout(function() {
							loadMoreNotesWithTag(tagGuid, FIRST_PAGE_SIZE, NTH_PAGE_SIZE);
						}, 1000);
					}
					else {
						$('.tags .loadingMore').hide();
						$('.submenu > li > a').each(function(index){
							if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
								$(this).css("text-decoration", "underline");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "underline")}
								);
							}
							else {
								$(this).css("text-decoration","none");
								$(this).hover(
									function(){$(this).css("text-decoration", "underline")}, 
									function() {$(this).css("text-decoration", "none")}
								);
							}
						})
					}
				}
			})(ii)

		}

	});	
}

function loadMoreNotes(start, numberOfNotes) {
	var filter = new NoteFilter();
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	$('.notes .loadingMore').show();

	noteStore.findNotes(authenticationToken, filter, start, numberOfNotes, function (noteList) {
		var nt = noteList.notes;

		for(var i = 0 ; i < nt.length; i++) {

			allNotes[nt[i].guid] = nt[i].notebookGuid;
			var dt = new Date(nt[i].updated);
			var cdt = new Date();
			var showDate = true;
			if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
				showDate = false;

			var hours = dt.getHours();
			if(hours > 12)
				hours = hours + 1;
			if(hours == 0) {
				hours = 12;
			} 
			hours = hours % 13;
			hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");

			$('#allNotes').append(
				$('<li>').attr('id','nt_'+nt[i].guid).append(
					$('<a />' , {
						href: "#",
						text: nt[i].title,
						class: "noteList"
					})
				).append($('<span>').attr('class','date-and-time')
				 .append(
					 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
				))
			);

			$('#nt_'+nt[i].guid).click(function(e) {
				var title = e.currentTarget.children[0].innerText;
				var guid = $(e.currentTarget).attr("id").split('nt_')[1];
				lastShowedNote = guid;
				loadNote(guid);

			});

			if(i == nt.length - 1) {
				if( (noteList.totalNotes > start + numberOfNotes) && (TOTAL_NOTES_LIMIT > start + numberOfNotes) ) {
					loadMoreNotes(start + numberOfNotes, numberOfNotes);						
				}
				else {
					$('.notes .loadingMore').hide();

					$('.submenu > li > a').each(function(index){
						if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
							$(this).css("text-decoration", "underline");
							$(this).hover(
								function(){$(this).css("text-decoration", "underline")}, 
								function() {$(this).css("text-decoration", "underline")}
							);
						}
						else {
							$(this).css("text-decoration","none");
							$(this).hover(
								function(){$(this).css("text-decoration", "underline")}, 
								function() {$(this).css("text-decoration", "none")}
							);
						}
					})
				}
			}
		}
	}, onAPIError);
}


function loadNotes() {
	//console.log('inside listing notes');

	$("#searchBox p").addClass("grayText");
	$("#searchBox p").attr("placeholder", "Find Note");

	if(changedNotes == false)
		return;
	else
		changedNotes = false;

	//console.log('inside listing notes...doing request...')
	var filter = new NoteFilter();
	filter.order = NoteSortOrder.UPDATED;
	filter.ascending = false;

	noteStore.findNotes(authenticationToken, filter, 0, FIRST_PAGE_SIZE, function (noteList) {
		var nt = noteList.notes;
		//console.log(noteList)
		$('#allNotes').html('');
		$('#numberOfNotes').html('('+noteList.totalNotes+')');

		for(var i = 0 ; i < nt.length; i++) {
			allNotes[nt[i].guid] = nt[i].notebookGuid;
			var dt = new Date(nt[i].updated);
			var cdt = new Date();
			var showDate = true;
			if(dt.getFullYear() == cdt.getFullYear() && dt.getMonth() == cdt.getMonth() && dt.getDate() == cdt.getDate())
				showDate = false;

			var hours = dt.getHours();
			if(hours > 12)
				hours = hours + 1;
			if(hours == 0) {
				hours = 12;
			} 
			hours = hours % 13;
			hours = hours + ":"+dt.getMinutes()+(dt.getHours() < 12 ? "am" : "pm");

			$('#allNotes').append(
					
				$('<li>').attr('id','nt_'+nt[i].guid).append(
						$('<a />' , {
							href: "#",
							text: nt[i].title,
							class: "noteList"/*, 
							style:"text-decoration:underline"*/
						})
					).append($('<span>').attr('class','date-and-time').append(
							 (showDate ? (dt.getDate()+"/"+(1+dt.getMonth())+"/"+(dt.getYear()-100) ):(hours))   
						))
				)
			$('#nt_'+nt[i].guid).click(function(e) {
				var title = e.currentTarget.children[0].innerText;
				var guid = $(e.currentTarget).attr("id").split('nt_')[1];
				lastShowedNote = guid;
				loadNote(guid);

			})

			if(i == nt.length - 1) {
				if(noteList.totalNotes > FIRST_PAGE_SIZE) {
					setTimeout(function() {
						loadMoreNotes(FIRST_PAGE_SIZE, NTH_PAGE_SIZE);
					}, 1000);
					
				}
				else {
					
					$('.submenu > li > a').each(function(index){
						if(localStorage['lastOpenedNote'] == $(this).parent().attr('id').split('_')[1]) {
							$(this).css("text-decoration", "underline");
							$(this).hover(
								function(){$(this).css("text-decoration", "underline")}, 
								function() {$(this).css("text-decoration", "underline")}
							);
						}
						else {
							$(this).css("text-decoration","none");
							$(this).hover(
								function(){$(this).css("text-decoration", "underline")}, 
								function() {$(this).css("text-decoration", "none")}
							);
						}
					})
				}
				}
		}
	}, onAPIError);
}

function searchNotebook() {
	var text = $("#searchBox > p").html().toLowerCase();

	$("#allNotebooks > li ").each(function(index) {
		$(this).show();
		if($(this).children(':first').html().toLowerCase().indexOf(text) < 0) {
			$(this).hide();
		}
	});
}

function searchTag() {
	var text = $("#searchBox > p").html().toLowerCase();

	$("#allTags > li").each(function(index) {
		$(this).show();
		if($(this).children(':first').html().toLowerCase().indexOf(text) < 0) {
			$(this).hide();
		}
	});
}

function searchNote() {
	var text = $("#searchBox > p").html().toLowerCase();

	$("#allNotes > li").each(function(index) {
		$(this).show();
		if($(this).children(':first').html().toLowerCase().indexOf(text) < 0) {
			$(this).hide();
		}
	});
}

function searchShortcut() {
	var text = $("#searchBox > p").html().toLowerCase();

	$("#allShortcuts > li").each(function(index) {
		$(this).show();
		if($(this).children(':first').html().toLowerCase().indexOf(text) < 0) {
			$(this).hide();
		}
	});
}

function loadNotebooks(notChange) {

	if(!notChange) {
		
		$("#searchBox p").addClass("grayText");
		$("#searchBox p").attr("placeholder", "Find Book");

		if(changedNotebooks == false)
			return;
		else
			changedNotebooks = false;
	}


	noteStore.listNotebooks(authenticationToken, 
		function (notebooks) {
	        $('#allNotebooks').html('');
	        $('#numberOfNotebooks').html('('+notebooks.length+')');
	        numberOfNotebooks = notebooks.length;
	       
			notebooks.sort(function(ntb1, ntb2) {
	       		return ntb1.name.localeCompare(ntb2.name);
	       	})
	       	
	        allNotebooks = {};
	        allNotebooksReversed = {};

	        for(var j = 0 ; j < notebooks.length; j++) {
	        	allNotebooks[notebooks[j].name] = notebooks[j].guid;
	        	allNotebooksReversed[notebooks[j].guid] = notebooks[j].name;
	        }
	        loadedNotebooks = true;

	        if(!notChange) {
	        	for(var ii = 0; ii < notebooks.length; ii++) {
	        		(function(noteb){
	        			console.log('Notebook: ' + noteb.name + ' , Stack: ' + noteb.stack);

	        			if(noteb.stack) {

	        				console.log('Notebook ' + noteb.name + ' present in stack ' + noteb.stack);

	        				allNotebookStacks[noteb.guid] = {
	        					'name': noteb.stack,
	        				};

		        			if(!allStacks[noteb.stack]) {
		        				allStacks[noteb.stack] = {
		        					'name': noteb.stack,
		        					'stackNotebookCount': 1
		        				};
		        				
		        				$('#allNotebooks').append(
		        					$('<li>').attr('class','ntb_stack').attr('data-stack-name', noteb.stack)
		        					.append(
		        						$('<i>', {
		        							class: 'fa fa-chevron-right'
		        						})
		        					)
		        					.append(
			        					$('<span>' , {
		        							href: "#",
		        							text: noteb.stack,
		        							class: "notebookStack"
		        						})
		        					).append($('<span>').attr('class','numeric-num stackNotesCount')
		        					).append(
	        							$('<ul>').attr('class', 'stackNotebooksList').attr('data-stack-name', noteb.stack)
	        						)
		        				);
		        			} else {
		        				allStacks[noteb.stack].stackNotebookCount += 1;
		        			}

		        			$('#allNotebooks').find('li.ntb_stack span.stackNotesCount').text(' (' + allStacks[noteb.stack].stackNotebookCount + ' notebooks)');	
		        		} 

	        			var filter = new NoteFilter();
						filter.notebookGuid = noteb.guid;									        		
						noteStore.findNotes(authenticationToken, filter, 0, 1, function (noteList) {
		        			
		        			var appendNoteTo;
		        			var notebookStack = allNotebookStacks[noteb.guid];

		        			if(notebookStack) {
		        				appendNoteTo = $('#allNotebooks').find('ul.stackNotebooksList[data-stack-name="' + notebookStack.name + '"]');
		        			} else {
		        				appendNoteTo = $('#allNotebooks');
		        			}
		        			appendNoteTo.append(
		        				$('<li>').attr('id','ntb_'+noteb.guid).append(
	        						$('<a />' , {
	        							href: "#",
	        							text: noteb.name,
	        							class: "nonNoteList"
	        						})
	        					).append($('<span>').attr('class','numeric-num').append(
        							' ('+noteList.totalNotes+' notes)'
        						))
		        			);
		        			$('#ntb_'+noteb.guid).click(function(e) {
		        				var title = e.currentTarget.children[0].innerText;
		        				var guid = $(e.currentTarget).attr("id").split('ntb_')[1];

		        				$('#ntbName').html(title);
		        				$('#numberOfNotebooks').html('('+noteList.totalNotes+')');
		        				changedNotebooks = true;
		        				allStacks = {};
		        				loadNotesFromNotebook(guid);
		        			});
		        		});	
		        		
						
	        		})(notebooks[ii]);
	        	}

	        	$('#allNotebooks').find('li.ntb_stack').on('click', function(event) {
	        		$(event.currentTarget).find('.stackNotebooksList').toggle();
	        		$(event.currentTarget).find('.fa').toggleClass('fa-chevron-right').toggleClass('fa-chevron-down');
	        	});
	        }
	    },onAPIError
	);
}

function loadTags(notChange, callback) {
	//console.log('inside listing tags');

	if(!notChange) {
		$("#searchBox p").addClass("grayText");
		$("#searchBox p").attr("placeholder", "Find Tag");


		if(changedTags == false)
			return;
		else
			changedTags = false;
	}



	noteStore.listTags(authenticationToken, function (tags) {
	        $('#allTags').html('');
	        $('#numberOfTags').html('('+tags.length+')');
	        numberOfTags = tags.length;
	        //console.log(tags);
	        allTags = {};
	        allTagsReversed = {};
	        for(var i = 0 ; i < tags.length; i++) {
	        	allTags[tags[i].name] = tags[i].guid;
	        	allTagsReversed[tags[i].guid] = tags[i].name;
	        }
	        loadedTags = true;

	        if(notChange && callback) {
	        	callback();
	        }
	        if(!notChange)
	        for(var ii = 0; ii < tags.length; ii++) {
	        	(function(i){
					var filter = new NoteFilter();
					filter.tagGuids = [tags[i].guid];									        		
					noteStore.findNotes(authenticationToken, filter, 0, 1, function (noteList) {

						$('#allTags').append(
							$('<li>').attr('id','tg_'+tags[i].guid).append(
									$('<a />' , {
										href: "#",
										text: tags[i].name, 
										class: "nonNoteList"
									})
								).append($('<span>').attr('class','numeric-num').append(
										' ('+noteList.totalNotes+')'
									))
							)
						$('#tg_'+tags[i].guid).click(function(e) {
							var title = e.currentTarget.children[0].innerText;
							var guid = $(e.currentTarget).attr("id").split('tg_')[1];
							$('#tgName').html(title);
							$('#numberOfTags').html('('+noteList.totalNotes+')')
							changedTags = true;
							loadNotesWithTag(guid);
						})
					});	        		
	        	})(ii);
	        	
	        }
	    },
	    function onerror(error) {
	        console.log(error);
	    }
	);
}

function insertElement(html) {
    var sel, range;
    
    sel = window.getSelection();
    if (sel.getRangeAt && sel.rangeCount) {
        range = sel.getRangeAt(0);
        range.deleteContents();

        // Range.createContextualFragment() would be useful here but is
        // only relatively recently standardized and is not supported in
        // some browsers (IE9, for one)
        var el = document.createElement("div");
        el.innerHTML = html;
        var frag = document.createDocumentFragment(), node, lastNode;
        while ( (node = el.firstChild) ) {
            lastNode = frag.appendChild(node);
        }
        range.insertNode(frag);

        // Preserve the selection
        if (lastNode) {
            range = range.cloneRange();
            range.setStartAfter(lastNode);
            range.collapse(true);
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
}
function setEndOfContenteditable(contentEditableElement)
{
    var range,selection;
    if(document.createRange)//Firefox, Chrome, Opera, Safari, IE 9+
    {
        range = document.createRange();//Create a range (a range is a like the selection but invisible)
        range.selectNodeContents(contentEditableElement);//Select the entire contents of the element with the range
        range.collapse(false);//collapse the range to the end point. false means collapse to end rather than the start
        selection = window.getSelection();//get the selection object (allows you to change selection)
        selection.removeAllRanges();//remove any selections already made
        selection.addRange(range);//make the range you have just created the visible selection
    }
}

function save() {
	sendMessageOverPort({ type: 'syncNotes', isNewNote: isNewNote });
}

function printWindowDimensions() {
	var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || e.clientWidth || g.clientWidth,
    y = w.innerHeight|| e.clientHeight|| g.clientHeight;

	var displayWidth = ((w.innerWidth < e.clientWidth) ? w.innerWidth : e.clientWidth);
	var realWidth = g.clientWidth; 
}

function addNewTag() {
	var tgName = $("#newTagBtn").html();
	if(!$("#newTagBtn").hasClass("ttN"))
		return;
	var htmlTags = $("#noteTagsList").html();
	htmlTags += "<li class=\"insideNoteTagList\">"+tgName+"</li>";
	$("#noteTagsList").html(htmlTags);

	noteStore.getNote(authenticationToken, localStorage['lastOpenedNote'], false, false, false, false, function(crtNote){
		if(crtNote.tagNames) {
			if(crtNote.tagNames.indexOf(tgName) < 0) {
				crtNote.tagNames[crtNote.tagNames.length] = tgName;
			}
		}
		else {
			crtNote.tagNames = [tgName];
		}

		crtNote.updated = (new Date()).getTime();
		noteStore.updateNote(authenticationToken, crtNote, function(newSavedNote) {
			var pos = $("#addNewTag").position();
			$("#newTagBtn").html('New tag...');
			$("#newTagBtn").removeClass('ttN');	
			$("#noteTags").css("top", pos.top-1+"px");
			$("#noteTags").css("left", pos.left-181+"px");	
			loadTags();
		})
		$("#newTagBtn").removeClass("showedHTMLTag");
		$("#newTagBtn").addClass("hiddenHTMLTag");

		$("#tagsBtn").removeClass("hiddenHTMLTag");
		$("#tagsBtn").addClass("showedHTMLTag");
	}, onAPIError);	

	nrClicksAddNewTagBtn = 0;
}

function notesSynced(msg) {
	var savedNote = msg.savedNote;

	if(isNewNote) {

		if(savedNote && savedNote.guid) {			
			$("#liSave").removeClass("sync-icon-wrap").addClass("sync-icon-wrap2");
			
			setTimeout(function(){
				$("#liSave").removeClass("sync-icon-wrap2").addClass("sync-icon-wrap").hide();
			}, 1300);
		}

		isNewNote = false;
		localStorage['isNewNote'] = false;

		$("#noteTagsList").html("");
		$("#noteTagsL").css("height", "0px");
	} 
	else {
		if(savedNote && savedNote.guid) {

			$("#liSave").removeClass("sync-icon-wrap").addClass("sync-icon-wrap2");
			
			setTimeout(function(){
				$("#liSave").removeClass("sync-icon-wrap2").addClass("sync-icon-wrap").hide();
			}, 1300);

			changedNotes = true;
			loadNotes();
			
			noteIsSaved = true;

			if($('.shortcut-icon-active').is(':visible')) {
				changedShortcuts = true;
				loadShortcuts();
			}

			if(isInsideNotebooks) {
				changedNotebooks = true;
				loadNotesFromNotebook(lastOpenedNotebook);
			}
			if(isInsideTags) {
				changedTags = true;
				loadNotesWithTag(lastOpenedTag);
			}
			localStorage['isNewNote'] = false;
		}
	}
}

function onAPIError(err) {
	if(err.errorCode === 19) {
		var timeOff = Math.ceil(err.rateLimitDuration / 60);
		console.warn('API rate limit reached. Please retry after ' + timeOff + ' minutes.');
	} else {
		console.warn('Unknown error occured in API: ' + err.message);
	}
}

$('document').ready(function(){
	
	if(localStorage['token']) { 
		var filter2 = new NoteFilter();
		filter2.order = NoteSortOrder.UPDATED;
		filter2.ascending = false;
		

		if(localStorage['lastOpenedNote']) {
			setTimeout(function(){
				loadNote(localStorage['lastOpenedNote']);

			}, 10);
		}
		else {
			noteStore.findNotes(authenticationToken, filter2, 0, 1, function (noteList) {
				if(noteList.notes.length > 0) {
					$('#title').html(noteList.notes[0].title);
					lastShowedNote = noteList.notes[0].guid;
					localStorage['lastOpenedNote'] = noteList.notes[0].guid;

					noteStore.getNoteContent(authenticationToken, noteList.notes[0].guid, function(content) {
						if(content.indexOf("<en-note></en-note>") >= 0) {
							$('.content-wrap p').html('');
							isEmptyNote = true;
						}
						else {
							$('.content-wrap p').html(content);
							$('.content-wrap p').focus();
						}

					}, onAPIError);

					noteStore.getNotebook(authenticationToken, noteList.notes[0].notebookGuid, function(ntb) {
						$('#currentFolder').html(ntb.name);
						localStorage[ntb.name] = (new Date()).getTime();
					}, onAPIError);

				}	
				else {
					noteStore.getDefaultNotebook(authenticationToken, function(notebook) {
						$('#currentFolder').html(notebook.name);
						allNotebooks[notebook.name] = notebook.guid;
						allNotebooksReversed[notebook.guid] = notebook.name;
					}, onAPIError);
				}
			}, onAPIError);
		}
		
		noteStore.listTags(authenticationToken, function(tags) {
			allTags = {};
			allTagsReversed = {};
			for(var i = 0 ; i < tags.length; i++) {
				if(tags[i].name == 'shortcuts') {
					shortcutsTagIsCreated = true;
					localStorage['shortcutsGuid'] = tags[i].guid;
				}
				allTags[tags[i].name] = tags[i].guid;
				allTagsReversed[tags[i].guid] = tags[i].name;
			}
			if(!shortcutsTagIsCreated) {
				var shortcutsTag = new Tag();
				shortcutsTag.name = "shortcuts";
				noteStore.createTag(authenticationToken, shortcutsTag, function(tag) {
					if(tag && tag.guid)
						localStorage['shortcutsGuid'] = tag.guid;
				})
			}
		}, onAPIError);

		noteStore.findNoteCounts(authenticationToken,filter2, false, function(data){
			
			numberOfNotebooks = Object.keys(data.notebookCounts).length;
			numberOfTags = Object.keys(data.tagCounts).length;
			$('#numberOfNotebooks').html('('+numberOfNotebooks+')');
			$('#numberOfTags').html('('+numberOfTags+')');
			var totalNumberOfNotes = 0;
			for(var ntb in data.notebookCounts) {
				if(data.notebookCounts.hasOwnProperty(ntb)) {
					totalNumberOfNotes = totalNumberOfNotes + data.notebookCounts[ntb];
				}
			}
			$('#numberOfNotes').html('('+totalNumberOfNotes+')');
			
		}, onAPIError);

		if(!loadedNotebooks) {
			loadNotebooks(true);	
		}

		setTimeout(function(){
			if(localStorage['lastOpenedTab'])
				$('#all'+localStorage['lastOpenedTab']+'A').get(0).click();
			else
				$('#allNotesA').get(0).click();
		}, 100);

		localStorage['lastOpenedNoteTimestamp'] = new Date().getTime();

	} //endif localStorage

	$('.todo-checkbox').on('mousedown', function(event) {
		event.preventDefault();
		return false;
	});

	$('.todo-checkbox').click(function(e) {
		e.preventDefault();
		if($('#content-box').is(':focus')) {
			insertElement(todoCheckbox);
			attachTodoClickHandler();
		}
		return false;
	});

	$('.purchase-license').click(function() {
		sendMessageOverPort({ type: 'purchaseLicense' });
		hideBuyLicenseBanner();
	});

	$('.close-banner').click(function() {
		hideBuyLicenseBanner();
	});

	$('#newNote').click(function(e) {
		e.preventDefault();     
		if(featuresAvailable) {
			$('#title').html('Untitled');
			$('.content-wrap p').html('<span class="grayText">New note here</span>');
			$('.content-wrap p').addClass('pN');
			localStorage['isNewNote'] = isNewNote = true;
			noteIsSaved = false;
			localStorage['oldNoteTitle'] = 'Untitled';
			localStorage['oldNoteContent'] = '';
			localStorage['oldNoteGuid'] = '';
			$(".shortcut-icon-active").addClass('shortcut-icon-wrap');
			$(".shortcut-icon-wrap").removeClass('shortcut-icon-active');	
            ga('send', 'event', { eventCategory: 'button', eventAction: 'click', eventLabel: 'newnotejs'});   
		}
		else {
			showTrialExpiredMessage();
		}
	})
	

	$('#addAsShortcut').click(function(e) {
		e.preventDefault();

		if(featuresAvailable) {
			if(localStorage['lastOpenedNote'] && localStorage['shortcutsGuid']) {
				noteStore.getNote(authenticationToken, localStorage['lastOpenedNote'], false, false, false, false, function(crtNote){

					var isRemoved = false;
					if(crtNote.tagGuids) {
						if(crtNote.tagGuids.indexOf(localStorage['shortcutsGuid']) < 0)
							crtNote.tagGuids[crtNote.tagGuids.length] = localStorage['shortcutsGuid'];
						else {
							var newTagGuids = [];
							for(var i = 0 ; i < crtNote.tagGuids.length; i++) {
								if(crtNote.tagGuids[i] != localStorage['shortcutsGuid']) {
									newTagGuids[newTagGuids.length] = crtNote.tagGuids[i];
								}
								else {
									//$(".shortcut-icon-active").addClass('shortcut-icon-wrap');
									//$(".shortcut-icon-wrap").removeClass('shortcut-icon-active');
									isRemoved = true;

								}
							}
							crtNote.tagGuids = newTagGuids;
						}

					}
					else
						crtNote.tagGuids = [localStorage['shortcutsGuid']];

					noteStore.updateNote(authenticationToken, crtNote, function(newSavedNote) {
						//console.log(newSavedNote);
						changedShortcuts = true;
						loadShortcuts();
						if(!isRemoved) {
							$(".shortcut-icon-wrap").addClass('shortcut-icon-active');
							$(".shortcut-icon-active").removeClass('shortcut-icon-wrap');
						}
						else {
							$(".shortcut-icon-active").addClass('shortcut-icon-wrap');
							$(".shortcut-icon-wrap").removeClass('shortcut-icon-active');
						}
						
					})
				})
			}
		} else {
			showTrialExpiredMessage();
		}
	});

	$('[contentEditable="true"]').on('click', 
		function (e) {
	        if ($(this).hasClass('pN')) {
	            $(this).html('');
	            $(this).removeClass('pN');
	        }

	        if ($(this).hasClass('fN')) {
	        	if(!$(this).hasClass('ttN')) {
	            	$(this).html('');

	        	}
	            $(this).removeClass('grayText');

	            if($(this).hasClass('tN')) {
	            	$(this).addClass('ttN')
	            }
	            
	        }
    	}
    )

	$('body').on('focus', '[contenteditable]', function(event) {
		if($(event.currentTarget).parent().attr('id') === 'searchBox') {
			if(!featuresAvailable) {
				event.preventDefault();
				showTrialExpiredMessage();
				return false;
			}
		}
	    var $this = $(this);
	    $this.data('before', $this.html());
	    return $this;
	}).on('keypress', '[contenteditable]', function(event) {
		// prevent enter keypress in search box
		if ( ($(event.currentTarget).parent().attr('id') === 'searchBox') && event.keyCode == 13) {
            event.preventDefault();
            return false;
        }
	}).on('blur keyup paste input', '[contenteditable]', function(event) {
	    var $this = $(this);
	     //console.log("2");
	    if ($this.data('before') !== $this.html()) {
	        $this.data('before', $this.html());
	        $this.trigger('change');
	        if(!$this.hasClass('fN')) {
	        	localStorage['oldNoteTitle'] = $("#title").html();
	        	localStorage['oldNoteContent'] = $('.content-wrap p').html();
	        	localStorage['oldNoteGuid'] = localStorage['lastOpenedNote'];
	        	noteIsSaved = false;
	        	$('#liSave').show();
	        }


	        if($this.hasClass('sB')) {
	        	
	        	$("#left-menu-items > li").each(function(index){
	        		if($(this).attr("class").indexOf("active") >= 0) {
	        			switch(index) {
	        				case 0: searchShortcut();  break;
	        				case 1: searchNote(); break;
	        				case 2: searchNotebook(); break;
	        				case 3: searchTag(); break;
	        			}
	        		}
	        	});
	        }
	        //tNP

	        if($this.hasClass('ttN')) {

	        	var pos = $("#addNewTag").position();
				$("#newTagList").css("left",pos.left-140+"px")
				$("#newTagList").css("top",pos.top+21+"px")

				var htmlTags = "";
				var nrTgs = 0;
				var allTags2 = Object.keys(allTags);
				for(var i = 0; i < allTags2.length; i++) {
					if(allTags2[i].indexOf($("#newTagBtn").html()) == 0) {
						htmlTags += "<li id=\"t_"+i+"\"><a class=\"insideTagList\" href=\"#\">"+allTags2[i]+"</a></li>";
						nrTgs = nrTgs + 1;
					}
				}
				
				$("#tagsList").html(htmlTags);

				for(var i = 0 ; i < allTags2.length; i++) {
					$("#t_"+i).click(function(ev){
						var indexTag = +ev.currentTarget.attributes[0].nodeValue.split('t_')[1];
						$("#newTagBtn").html(allTags2[indexTag]);

						$("#newTagList").hide();
					})
				}

				var hg = nrTgs*30 + 3;
				if(nrTgs == 0)
					hg = 0;
				if(hg>90)
					hg = 90;
				$("#newTagList").css("height", hg+"px");

				if(nrTgs > 0)
					$("#newTagList").show();


				var text = $("#newTagBtn").html();
				if(text.indexOf("<br>") >= 0) {
					text = text.replace(/<br>/g,'');
					$("#newTagBtn").html(text);
					addNewTag();
				}
	        }

	        if(event.originalEvent.inputType === "insertFromPaste") {
        		var allNodes = $(".editingBox en-note").find("*");
        		console.log('note edited via paste event, removing id attr from all element nodes: ' + allNodes.length);
        		allNodes.each(function() {
        			$(this).removeAttr('id');
        			$(this).removeAttr('style');
        			$(this).removeAttr('class');
        		});
	        }
	    }

	    return $this;
	});

	$("#tagsBtn").click(function(e) {

		var pos = $("#addNewTag").position();
		$("#noteTagsL").css("top", pos.top+27+"px");
		$("#noteTagsL").css("left", pos.left-140+"px")

		$("#noteTagsL").show();
	})

	$('#save').click(function(){
		save();
	})

	$('#bottom-left-div > ul > li').click(function(e) {
		e.preventDefault();
		$('#ntbName').html('Notebooks');
		$('#numberOfNotebooks').html('('+numberOfNotebooks+')');
		$('#tgName').html('Tags');
		$('#numberOfTags').html('('+numberOfTags+')');
	})

	$('#allTagsA').click(function(e){
		clickedTags = true;
	});

	$('#allNotebooksA').click(function(e){
		clickedNotebooks = true;
	})

	$('#allNotesA').click(function(e){
		clickedNotes = true;
	})

	$('#allShortcutsA').click(function(e){
		clickedShortcuts = true;
	})

	$('#loadNotes').click(function(e) {
		e.preventDefault();
       
		if($(".fullscreen_arrow").is(':visible')) {
			$(".fullscreen_arrow").click();
		}

		localStorage['lastOpenedTab'] = 'Notes';
		if(notesClickedFirstTime == false) {
			$('#allNotesA').get(0).click();
			notesClickedFirstTime = true;
		}
		$("#searchBox p").attr("placeholder", "Find Note");
	});

	$('#loadNotebooks').click(function(e) {
		e.preventDefault();

		if($(".fullscreen_arrow").is(':visible')) {
			$(".fullscreen_arrow").click();
		}

		var listed1 = false;

		if(notebooksClickedFirstTime == false) {
			setTimeout(function(){
				$('#allNotebooksA').get(0).click();
			}, 550);
			listed1 = true;
			notebooksClickedFirstTime = true;
		}

		if(isInsideNotebooks && !listed1) {
			loadNotebooks();

			if(lastOpenedTab =='Notebooks' && clickedNotebooks == false) {
				//console.log('click on allNotebooksA button')
				$('#allNotebooksA').get(0).click();
				lastOpenedTab = '';
			}
			isInsideNotebooks = false;
			listed1 = true;
		}

		localStorage['lastOpenedTab'] = 'Notebooks';
		$("#searchBox p").attr("placeholder", "Find Book");

	});

	$('#loadTags').click(function(e) {
		e.preventDefault();

		if($(".fullscreen_arrow").is(':visible')) {
			$(".fullscreen_arrow").click();
		}

		var listed2 = false;
		if(tagsClickedFirstTime == false) {
			setTimeout(function() {
				$('#allTagsA').get(0).click();
			}, 550);
			
			listed2 = true;
			tagsClickedFirstTime = true;
		}
		if(isInsideTags && !listed2) {
			loadTags();

			if(lastOpenedTab == 'Tags' && clickedTags == false) {
			//	console.log('click on allTagsA button');
				$('#allTagsA').get(0).click();
				lastOpenedTab = '';
			}
			isInsideTags = false;
			listed2 = true;
		}

		localStorage['lastOpenedTab'] = 'Tags';
		$("#searchBox p").attr("placeholder", "Find Tag");
	});

	$('#loadShortcuts').click(function(e) {
		e.preventDefault();

		if($(".fullscreen_arrow").is(':visible')) {
			$(".fullscreen_arrow").click();
			//$("#arrow-wrap a.not_fullscreen_arrow").click();
		}

		if(shortcutsClickedFirstTime == false) {
			setTimeout(function() {
				$('#allShortcutsA').get(0).click();
			}, 550);
			shortcutsClickedFirstTime = true;
		}
		localStorage['lastOpenedTab'] = 'Shortcuts';
		$("#searchBox p").attr("placeholder", "Find Note");
	})

	$('.not_fullscreen_arrow').click(function(e) {
		e.preventDefault();
		localStorage['fullscreen'] = 'yes';
	})
	$('.fullscreen_arrow').click(function(e) {
		e.preventDefault();
		localStorage['fullscreen'] = 'no';
	})

	setTimeout(function(){
		if(localStorage['fullscreen'] == 'yes') {
			$('.not_fullscreen_arrow').click();
		}
	}, 20);


	//left tab item
	$("#left-menu-items > li > a").click(function(e){
		e.preventDefault();
		$(this).next('.submenu').slideToggle();		


		switch(localStorage['lastOpenedTab']) {
			case 'Shortcuts':
						shortcutsClickedFirstTime = true;
						loadShortcuts(); break;
			case 'Tags' : 
						tagsClickedFirstTime = true; 
						loadTags(); 
						break;
			case 'Notebooks': 
						notebooksClickedFirstTime = true;
						loadNotebooks(); 
						break;
			default:
					notesClickedFirstTime = true;
					loadNotes();
		}

	});			
	

	// Changing right div heading
	$("#left-menu-items .submenu li a").click(function(e) {
		e.preventDefault();
		var menuName = $(this).html();
		$(".section-header h3").html(menuName);
	});				
	
	

	/**---------------TABS-------------**/
	$(".tab-list .tab1 a").click(function(e) {
		e.preventDefault();
		$(".tabs .active").removeClass("active");
		$(".tab1").addClass("active");
	});
	
	$(".tab-list .tab2 a").click(function(e) {
		e.preventDefault();
		$(".tabs .active").removeClass("active");
		$(".tab2").addClass("active");
	});
	
	$(".tab-list .tab3 a").click(function(e) {
		e.preventDefault();
		$(".tabs .active").removeClass("active");
		$(".tab3").addClass("active");
	});	
	
	$(".tab-list .tab4 a").click(function(e) {
		e.preventDefault();
		$(".tabs .active").removeClass("active");
		$(".tab4").addClass("active");
	});	
	

	
	
	// more button
	$("#more-icon").click(function(e){ 
		e.preventDefault(e);
		$("#popsup_box").slideToggle();	
		
	});

	$(".small-down-arrow").click(function(e){
		e.preventDefault(e);
		if(featuresAvailable == false) {
			showTrialExpiredMessage(); 
			return;
		}

		var pos = $(".small-down-arrow").position();
		$("#notebooks_box").css("left",pos.left+11+"px")
		$("#notebooks_box").css("top",pos.top+13+"px")

		var notebooks = Object.keys(allNotebooks);

		$("#notebooksList").html('');

		notebooks.sort(function(ntb1, ntb2) {
	       	return ntb1.localeCompare(ntb2);
	    });

		var hg = 30*notebooks.length + 12;
		if(hg > 160)
			hg = 160;

		$("#notebooks_box").css("height",hg+"px")

		var htmlNotebooks = ""
		for(var i = 0; i < notebooks.length; i++) {
			htmlNotebooks += "<li id=\"f_"+allNotebooks[notebooks[i]]+"\"><a class=\"insideNotebooks\" href=\"#\">"+notebooks[i]+"</a></li>";
		}

		$("#notebooksList").html(htmlNotebooks);

		for(var i = 0 ; i < notebooks.length; i++) {
			$("#f_"+allNotebooks[notebooks[i]]).click(function(ev){
				var newGuid = ev.currentTarget.attributes[0].nodeValue.split('f_')[1];

				if(newGuid != allNotebooks[notebooks[i]]) {
					noteStore.getNote(authenticationToken, localStorage['lastOpenedNote'], false, false, false, false, function(crtNote){
						
						crtNote.notebookGuid = newGuid;
						crtNote.updated = (new Date()).getTime();
						noteStore.updateNote(authenticationToken, crtNote, function(newSavedNote) {
							var newNotebookName = ev.currentTarget.children[0].innerText;
							$('#currentFolder').html(newNotebookName);
							$("#notebooks_box").slideToggle();	
						})
					})
				}
			})
		}

		$("#notebooks_box").slideToggle();	
	});


	$('body').click(function(e) {
		e.preventDefault(e);
		
		if(e.target.className !== "insideMoreIcon") {
			$("#popsup_box").hide();
		}
		if(e.target.className.indexOf("insideNotebooks") < 0) {
			$("#notebooks_box").hide();
		}

		if(e.target.className.indexOf("insideNotebooks") < 0) {
			$("#newTagList").hide();
		}

		if(e.target.className.indexOf("insideNoteTagList") < 0) {
			$("#noteTagsL").hide();
		}

		if(e.target.className.indexOf("insideAttachments") < 0) {
			$("#attachmentsL").hide();
		}

		if(e.target.className.indexOf("sB") < 0) {
			showSearchBoxPlaceholder();
		}
		else {
			$("#searchBox p").removeClass("grayText");
			
		}

		if(!noteIsSaved && e.target.className.indexOf("editingBox") < 0) {
			
			var tg = e.target.parentNode;
			var insideEditingBox = false;
			while(tg && tg.className.indexOf("tabs") < 0) {
				if(tg.className.indexOf("editingBox") >= 0) {
					insideEditingBox = true;
					break;
				}
				tg = tg.parentNode;
			}
			if(!insideEditingBox) {
				save();
			}
		}

		if(e.target.className.indexOf("ttN") < 0 && e.target.className.indexOf("insideTagList") < 0) {
			$("#newTagBtn").html('New tag...');
			$("#newTagBtn").removeClass('ttN');
		}
	})


	$('#addNewTag').click(function(e) {
		e.preventDefault();

		if(featuresAvailable == false) {
			showTrialExpiredMessage();
			return;
		}

		if(nrClicksAddNewTagBtn == 0 && $("#tagsBtn").is(':visible')) {
			$("#tagsBtn").removeClass("showedHTMLTag");
			$("#tagsBtn").addClass("hiddenHTMLTag");

			$("#newTagBtn").removeClass("hiddenHTMLTag");
			$("#newTagBtn").addClass("showedHTMLTag");
			nrClicksAddNewTagBtn = nrClicksAddNewTagBtn + 1;
			return;
		}
		else {
			addNewTag();
		}
		
	});

	$("#attachmentBtn").click(function(e) {
		e.preventDefault();
		var pos = $("#belowLine").position();
		$("#attachmentsL").css("top", pos.top-($("#attachmentsL").height())+(20+42)+"px");
		$("#attachmentsL").css("left", pos.left+3+"px");
		$("#attachmentsL").show();
	});


	$("#openEvernote").click(function(e) {
		e.preventDefault(e);
		if(!localStorage['lastOpenedNote'])
			window.open('https://www.evernote.com/Home.action', '_blank');
		else
			window.open('https://www.evernote.com/Home.action#st=p&n='+localStorage['lastOpenedNote'], '_blank');
	});

	$("#popoutView").click(function(e) {
		e.preventDefault(e);
		if(featuresAvailable) {
			window.open (document.URL, "Evernote for chrome","menubar=1,resizable=1,width=820,height=564");
		} else {
			showTrialExpiredMessage();
		}
	});

	$("#share").click(function(e) {
		e.preventDefault(e);
		window.open('http://www.facebook.com/sharer.php?u=' + webstoreLink,'Facebook - Google Chrome','menubar=1,resizable=1,width=670,height=345');
	})

	$("#moreApps").click(function(e) {
		e.preventDefault(e);
		window.open(webstoreLink);
        
	})

	$("#feedback").click(function(e) {
		e.preventDefault(e);
		window.open(webstoreLink + '/support/?extension');
	})

	$("#reviews").click(function(e) {
		e.preventDefault(e);
		window.open(webstoreLink + "/reviews/?extension")
	})

	$("#getPremiumLink").click(function(e) {
		e.preventDefault(e);
		sendMessageOverPort({ type: 'purchaseLicense' });
	})

	$("#loggout").click(function(e) {
		e.preventDefault(e);
		userStore.revokeLongSession(localStorage['token'], function() {

		});
		localStorage['token'] = '';
		$("#container").hide();
		$("#lgnBtn").show();
	})
});

var showSearchBoxPlaceholder = function () {
	$("#searchBox p").addClass("grayText");
	$("#left-menu-items > li").each(function(index){
		if($(this).attr("class").indexOf("active") >= 0) {
			switch(index) {
				case 0: $("#searchBox p").attr("placeholder", "Find Note");  break;
				case 1: $("#searchBox p").attr("placeholder", "Find Note"); break;
				case 2: $("#searchBox p").attr("placeholder", "Find Book"); break;
				case 3: $("#searchBox p").attr("placeholder", "Find Tag"); break;
			}
		}
	});
}

var resizeWindow = function() {
		//console.log("resize")
		var w = window,
		    d = document,
		    e = d.documentElement,
		    g = d.getElementsByTagName('body')[0],
		    x = w.innerWidth || e.clientWidth || g.clientWidth,
		    y = w.innerHeight|| e.clientHeight|| g.clientHeight;

		var displayWidth = ((w.innerWidth < e.clientWidth) ? w.innerWidth : e.clientWidth);
		var realWidth = g.clientWidth; 
		var displayHeight = ((w.innerHeight < e.clientHeight) ? w.innerHeight : e.clientHeight);
		var realHeight = g.clientHeight; 

		//displayHeight = 440;
		//displayWidth = 580;
		//console.log("displayWidth = ", displayWidth);
		//console.log("realWidth = ", realWidth)
		//pt test
		//realWidth = 780;
		//displayWidth = 640;
    	var pos = $("#addNewTag").position();
		$("#noteTags").css("top", pos.top-3+"px");
		$("#noteTags").css("left", pos.left-181+"px");
		/*$("#attachments").css("top", pos.top-2+"px");
		$("#attachments").css("left", pos.left-230+"px");*/
		placeAttachmentDiv(true);
		/*$("#noteTagsL").css("top", pos.top+30+"px");
		$("#noteTagsL").css("left", pos.left-180+"px")*/
		$("#noteTagsL").css("top", pos.top+27+"px");
		$("#noteTagsL").css("left", pos.left-140+"px")

		
		if(780 > displayWidth) {
			if(displayWidth < 540)
				return;

			var leftDivProc = 30;
			var leftDivWidth = leftDivProc*displayWidth/100;
			//console.log('leftDivWidth =', leftDivWidth)
			while(leftDivWidth < 200) {
				leftDivProc = leftDivProc + 1;
				leftDivWidth = leftDivProc*displayWidth/100;
				//console.log(leftDivProc);
			}



			var x = 75*leftDivWidth/100 - 52;
			//console.log(displayWidth, x);
			document.getElementById("container").style["min-width"] = ""+displayWidth+"px";
			document.getElementById("searchBox").style["width"] = ""+x+"px";
			if($(".not_fullscreen_arrow").is(':visible')) {
				document.getElementById("left-div").style["width"] = ""+leftDivProc+"%";
				document.getElementById("right-div").style["width"] = ""+(100 - leftDivProc - 4)+"%";
			}
		}
		else {
			var leftDivProc = 30;
			var leftDivWidth = leftDivProc*displayWidth/100;

			while(leftDivWidth > 350) {
				leftDivProc = leftDivProc - 1;
				leftDivWidth = leftDivProc*displayWidth/100;
				//console.log(leftDivProc)
			}
			var x = 75*leftDivWidth/100 - 52;
			document.getElementById("container").style["min-width"] = ""+displayWidth+"px";
			document.getElementById("searchBox").style["width"] = ""+x+"px";
			if($(".not_fullscreen_arrow").is(':visible')) {
				document.getElementById("left-div").style["width"] = ""+leftDivProc+"%";
				document.getElementById("right-div").style["width"] = ""+(100 - leftDivProc - 4)+"%";
			}
		}

		var offset = displayHeight - 523;
		$('#left-div').css('height', 520+offset+"px");
		$('#sep-div').css('height', 520+offset+"px");
		$('#right-div').css('height', 520+offset+"px");
		$('.submenu').css('height', ""+(320+offset+7));
		$('.content-wrap').css('height', ""+(375+offset)+"px")
		$('.content-wrap p').css('height', ""+(350+offset - 140+110)+"px");
}


$('document').ready(function(){
	placeAttachmentDiv(true);

	$("#arrow-wrap a.fullscreen_arrow ").hide();
	
	$("#arrow-wrap a.not_fullscreen_arrow ").click(function(e){ 
		e.preventDefault();
        
		$("div#left-div").animate({
				position: "relative",
				width: "60px",
			}, 500, function() {
			// Animation complete.
		});

		$("#right-div").animate({
				position: "relative",
				width: "85%",
			}, 500, function() {
			// Animation complete.
		});
		
		$(".btm-left-menu-items li").css({'margin-left':'0px', 'float' : 'none' });
		$(".btm-left-menu-items").css({ 'width' : '52px', 'margin-left' : 'auto', 'margin-right' : 'auto' });
									
		$("#arrow-wrap").css({'width' : '28px', 'margin-left' : 'auto', 'margin-right' : 'auto', 'float' : 'none' });
							
		$("div#search").hide();				
		$("div.left-menu-wrap").hide();
		
		$(this).hide();	
		$("#arrow-wrap a.fullscreen_arrow ").show();
	
	});

	$("#arrow-wrap a.fullscreen_arrow ").click(function(e){
		e.preventDefault();
		
		$("div#left-div").animate({
				position: "relative",
				width: "30%",
			}, 500, function() {
			// Animation complete.
		});
		
		$("#right-div").animate({
				position: "relative",
				width: "66%",
			}, 500, function() {
			$("div#search").show();
			$("div.left-menu-wrap").show();
		});				
		
			
		$(".btm-left-menu-items li").css({ 'margin-left' : '0px', 'float' : 'left' });
		$(".btm-left-menu-items").css({ 'width' : 'auto' });
		$("#arrow-wrap").css({'width' : '28px', 'float' : 'right', 'margin-right' : '10px' });
		$(this).hide();
		$("#arrow-wrap a.not_fullscreen_arrow ").show();
	});

	$("#smallSearchIcon").click(function(e){
		
		$("#left-menu-items > li").each(function(index){
			
			if($(this).attr("class").indexOf("active") >= 0) {
				switch(index) {
					case 0: searchShortcut();  break;
					case 1: searchNote(); break;
					case 2: searchNotebook(); break;
					case 3: searchTag(); break;
				}
			}
		})

	});


	var pos = $("#addNewTag").position();
	$("#noteTags").css("top", pos.top-3+"px");
	$("#noteTags").css("left", pos.left-181+"px");
	$("#noteTagsL").css("top", pos.top+27+"px");
	$("#noteTagsL").css("left", pos.left-140+"px")

	$("#attachments").css("top", pos.top-2+"px");
	$("#attachments").css("left", pos.left-230+"px");
				
});			

$(window).resize(function(){
	resizeWindow();
});
	
chrome.runtime.sendMessage({type: "badge"}, function(resp) {

});

resizeWindow();

// Standard Google Universal Analytics code
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','https://www.google-analytics.com/analytics.js','ga'); // Note: https protocol here
 
ga('create', 'UA-66081100-1', 'auto');
ga('set', 'checkProtocolTask', function(){}); // Removes failing protocol check. @see: http://stackoverflow.com/a/22152353/1958200
ga('require', 'displayfeatures');
ga('send', 'pageview', '/popup.html');
// standard google ends